using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;


namespace BigSock.UI
{
  public class AbilityElement : MonoBehaviour
  {
    private Slider chargeSlider, cooldownSlider;
    private Image _sprite;

    public AbilityElement WithCharge(float? value = null, float? maxValue = null)
    {
        if (value != null) chargeSlider.value = value.Value;

        if (maxValue != null) chargeSlider.maxValue = maxValue.Value;
        return this;
    }
        
    public AbilityElement WithCooldown(float? value = null, float? maxValue = null)
    {
        if (value != null) cooldownSlider.value = value.Value;

        if (maxValue != null) cooldownSlider.maxValue = maxValue.Value;
        return this;
    }


    public AbilityElement WithAbility(AbilityEntity ability) {
      _sprite ??= transform.Find("Sprite").GetComponent<UnityEngine.UI.Image>();

      if (_sprite != null)
          _sprite.overrideSprite = ability.Ability.Icon ?? _sprite.overrideSprite;
      return this;
    }


    // Start is called before the first frame update
    void Start() {
      chargeSlider = transform.Find("ChargeSlider").GetComponent<Slider>();
      cooldownSlider = transform.Find("ReloadSlider").GetComponent<Slider>();
      _sprite ??= transform.Find("Sprite").GetComponent<UnityEngine.UI.Image>();
    }

    // Update is called once per frame
    void Update()
    {

    }
    }
}
