﻿using BigSock.Item;
using System.Collections;
using UnityEngine;
using UnityEngine.EventSystems;

namespace BigSock.UI
{
	public class InvTrash : MonoBehaviour, IDropHandler
	{
		public Inventory inventory;
		public void OnDrop(PointerEventData eventData)
		{
			// Get the item prefab that was dropped.
			var itemPref = eventData?.pointerDrag?.GetComponent<ItemPref>();

			// Cancel if we didn't move an item prefab, or it was empty.
			if (itemPref?.item == null) return;

			// Try to move the item in the inventory.
			var didMove = inventory.DropItem(
				itemPref.item, itemPref.itemSlot.inventoryType,
				itemPref.itemSlot.position) ;

			// If we successfully moved the item in the inventory: update the gui.
			if (didMove) itemPref.itemSlot.item = null;

			Destroy(itemPref.gameObject);

			/*
			Notes:
			- This doesn't handle what to do if this slot already had an item.
				- This isn't a problem currently, since the inventory system will refuse to move an item into an occupied slot.
				- If we want to add features to swap 2 items, this will need to be addressed.
			*/
		}
	}
}